/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the MessageContactEmail type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessageContactEmail{}

// MessageContactEmail struct for MessageContactEmail
type MessageContactEmail struct {
	Email string `json:"email"`
	Type *string `json:"type,omitempty"`
}

// NewMessageContactEmail instantiates a new MessageContactEmail object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageContactEmail(email string) *MessageContactEmail {
	this := MessageContactEmail{}
	this.Email = email
	return &this
}

// NewMessageContactEmailWithDefaults instantiates a new MessageContactEmail object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageContactEmailWithDefaults() *MessageContactEmail {
	this := MessageContactEmail{}
	return &this
}

// GetEmail returns the Email field value
func (o *MessageContactEmail) GetEmail() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Email
}

// GetEmailOk returns a tuple with the Email field value
// and a boolean to check if the value has been set.
func (o *MessageContactEmail) GetEmailOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Email, true
}

// SetEmail sets field value
func (o *MessageContactEmail) SetEmail(v string) {
	o.Email = v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *MessageContactEmail) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContactEmail) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *MessageContactEmail) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *MessageContactEmail) SetType(v string) {
	o.Type = &v
}

func (o MessageContactEmail) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessageContactEmail) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["email"] = o.Email
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	return toSerialize, nil
}

type NullableMessageContactEmail struct {
	value *MessageContactEmail
	isSet bool
}

func (v NullableMessageContactEmail) Get() *MessageContactEmail {
	return v.value
}

func (v *NullableMessageContactEmail) Set(val *MessageContactEmail) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageContactEmail) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageContactEmail) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageContactEmail(val *MessageContactEmail) *NullableMessageContactEmail {
	return &NullableMessageContactEmail{value: val, isSet: true}
}

func (v NullableMessageContactEmail) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageContactEmail) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


